﻿<template>
    <Suspense :key="movie.id">
        <ShowMovie v-if="movie" :movie="movie" :genre="genreParams.genreFR"></ShowMovie>
        <section v-else class="error-show-movie">
            <h1>{{ t('pages.showMovie.error') }}</h1>
            <p>{{errorMessage}}</p>
            <button class="btn"><RouterLink :to="t('routes.home.path')" class="navbar__navlink">{{ t('pages.showMovie.backHomeButton') }}</RouterLink></button>
        </section>
        <template #fallback>
            <Loader />
        </template>
    </Suspense>
</template>

<script lang="ts" setup>
    import Loader from "@/components/layout/Loader.vue";
    import ShowMovie from "@/components/movies/ShowMovie.vue";
    import { useRoute } from 'vue-router';
    import { useI18n } from "vue3-i18n";
    import { useMovieService, useMemberService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
    import { Mood, MOODS } from "@/types/entities/mood";
    import { Movie } from "@/types/entities/movie";
    import { selectRandomMovie, hasMemberSeenMovie } from "@/utils/movieUtils";

    const route = useRoute();
    const { t } = useI18n();
    const movieService = useMovieService();
    const memberService = useMemberService();
    const memberStore = useMemberStore();

    let movie: Movie | undefined;
    let errorMessage: string;
    
    let idMood = parseInt(route.params.id.toString());
    if (idMood < 0 || idMood >= MOODS.length)
        idMood = 0;

    const mood = MOODS[idMood];
    const genreParams = getRandomGenreParams(mood);

    const movies = await movieService.getRandomMovieWithGenre(genreParams.genre);

    if (movies.movies) {

        if (memberStore.member.email) {
            const member = await memberService.getMemberWithId(memberStore.member.id)
            let movieGuess: Movie

            do {
                movieGuess = selectRandomMovie(movies);
                movies.movies = movies.movies.filter(movie => movie.title !== movieGuess.title);
            } while (hasMemberSeenMovie(member, movieGuess) && movies.movies.length > 0);

            if (movies.movies.length > 0)
                movie = movieGuess;
            else
                errorMessage = t('validation.movie.allSeen');
        }
        else {
            movie = selectRandomMovie(movies);
        }
    }
    else 
        errorMessage = t('validation.movie.noMovie');
    
    function getRandomGenreParams(mood: Mood) {
        const genreIndex = Math.floor(Math.random() * mood.genres.length)
        const genre = mood.genres[genreIndex]
        const genreFR = mood.genreFR[genreIndex]
        return { genreIndex, genre, genreFR }
    }
</script>